<?php
fclose(STDIN);
fclose(STDOUT);
fclose(STDERR);
$STDIN = fopen('/dev/null', 'r');
$STDOUT = fopen('application.log', 'a');
$STDERR = fopen('error.log', 'a');

if(!file_exists('block.txt')){
	touch('block.txt');
}

$fp = fopen('block.txt', 'r+');

/* Activate the LOCK_NB option on an LOCK_EX operation */
if(!flock($fp, LOCK_EX | LOCK_NB)) {
    die('already running....');
}


if(!file_exists('./threads')){
	echo("I need a subdir called threads, but it does not exist. Attempting to create it\n\r");
	if(!mkdir('./threads')){
			echo("Can't create directory, exiting\n\r");
			exit;
	}
} elseif (!is_dir('./threads')){
	echo("I need a subdir called threads, but there is a file with this name, exiting\n\r");
	exit;
} elseif (!is_writable('./threads')){
	echo("Can't write to threads, exiting\n\r");
	exit;
}

if(!file_exists('./watermarks')){
	echo("I need a subdir called watermarks, but it does not exist. Attempting to create it\n\r");
	if(!mkdir('./watermarks')){
			echo("Can't create directory, exiting\n\r");
			exit;
	}
} elseif (!is_dir('./watermarks')){
	echo("I need a subdir called watermarks, but there is a file with this name, exiting\n\r");
	exit;
} elseif (!is_writable('./watermarks')){
	echo("Can't write to watermarks, exiting\n\r");
	exit;
}

/*

all the config stuff, edit to your needs

*/

$news_server = array();

$news_server['0'] = array(
			'name' => 'rslight',
			'server' => '127.0.0.1',
			'port' => '10119',
			'user' => 'username',
			'pass' => 'password',
);

$news_server['1'] = array(
			'name' => 'retros_inn',
			'server' => '192.168.1.1',
			'port' => '55960',
			'user' => 'user',
			'pass' => 'pass',
);

$actual = $news_server[array_rand($news_server)];
$name = $actual['name'];
$server = $actual['server'];
$port = $actual['port'];
$user = $actual['user'];
$pass = $actual['pass'];
echo("Using server:\n\r");
print_r($actual);

include 'NNTP.php';
include 'vichan_nntp.php';

$groups = array(
	'rocksolid.nodes',
	'rocksolid.nodes.help',
	'rocksolid.nodes.announce',
	'rocksolid.shared.encryption',
	'rocksolid.shared.entertainment',
	'rocksolid.shared.freenet',
	'rocksolid.shared.general',
	'rocksolid.shared.hacking',
	'rocksolid.shared.helpdesk',
	'rocksolid.shared.i2p',
	'rocksolid.shared.linux',
	'rocksolid.shared.news',
	'rocksolid.shared.offtopic',
	'rocksolid.programming',
	'rocksolid.shared.rocksolid',
	'rocksolid.shared.security',
	'rocksolid.social',
	'rocksolid.shared.test',
	'rocksolid.shared.tor',
);


/*

the control flow of the program

*/

$nntp = new SSP\NNTP\NNTP();
$offline = false;
$no_update = false; 
if(!$nntp->connect($server, $port)){
	echo("can't connect to " . $server . " at " . $port . "\n\r");
	$offline = true;
} elseif( (!$nntp->autentifizierung($user, $pass)) && (!$nntp->authModeReader($user, $pass)) ){
	echo("can't pass auth with the credentials for " . $user . "\n\r");
	$offline = true;
} else {
	echo("auth succesful for " . $user .  "\n\r");
	if(!$watermarks = $nntp->listGroups()){
		echo("can't get group information\n\r");
		$no_update = true;
	} else {
		$groupInfo = array();
		foreach($watermarks as $info){
			$group = $info['0'];
			$groupInfo[$group] = array();
			$hikey = (int) $info['1'];
			$lowkey = (int) $info['2'];
			$groupInfo[$group][] = $hikey;
			$groupInfo[$group][] = $lowkey;
		}
	}
}

if( (!$offline) && (!$no_update) ){
	foreach($groups as $group){
		if(!file_exists('./threads/xt_' . $group . '.json')){
			echo("no index found for group " . $group . ", building it \n\r");
			build_threads($group, $nntp, $groupInfo, $name);
		} 
	}
	update_threads($groups, $nntp, $groupInfo, $name);
	send_messages("/var/www/html/vi/vichan-master/debug/outgoing/");
}
foreach($groups as $group){
	$threads = json_decode(file_get_contents('./threads/xt_' . $group . '.json'), true);
	$thread_keys = array_keys($threads);
	for ($i = 0; $i < 10; $i++){
		$threads = stage($thread_keys, $threads);
	}
	$jsonFile = fopen('./threads/xt_' . $group . '.json', 'w');
	fwrite($jsonFile, json_encode($threads, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
	fclose($jsonFile);
	update_sync($threads, $group);
}
if( (!$offline) && (!$no_update) ){
	echo("succesful run, taking a break for 2 min....\n\r");
	sleep(120);
} else {
	echo("no luck on this run, exiting right away....\n\r");
}
echo("exiting now....\n\r");
fclose($fp);
exit;

/*

now comes the code that gets the messages and builds the index files

*/

function get_message($i, $group, $nntp){
	$jsonMessage = array();
	$head = $nntp->getHead($i, $group);
	if(!$head){
		return false;
	}
	foreach($head as $field){
		if( (isset($field['0'])) && (isset($field['1'])) && ($field['0']) && ($field['1']) ){
			$key = trim((string) $field['0']);
			$value = trim($field['1']);
			if( ($value) && ($key) ){
				$jsonMessage[$key] = array();
				$jsonMessage[$key][] = $value;
			}
		}
	}
	if(isset($jsonMessage['Message-ID']['0'])){
		$ID = $jsonMessage['Message-ID']['0'];
	} elseif (isset($jsonMessage['Message-Id']['0'])){
		$ID = $jsonMessage['Message-Id']['0'];
	} else {
		return false;
	}
	return $jsonMessage;
}


function build_threads($group, $nntp, $groupInfo, $name){
	$watermarks = array();
	$threads = array();
	$watermarks[$group] = array();
	echo("building index for group " . $group . "\n\r");
	$hi = ( $groupInfo[$group][0] + 1);
	$lo = $groupInfo[$group][1];
	if($lo < 1){
		$lo = 1;
	}
	for ($i = $lo; $i < $hi; $i++){
			$message = get_message($i, $group, $nntp);
			if( ($message) && ($message['Message-ID']['0']) ){
				echo("processing message # " . $i . " from group " . $group . "\r");
				$ID = trim($message['Message-ID']['0']);
				$threads[$ID] = array();
				$threads[$ID]['parents'] = array();
				$threads[$ID]['synced'] = false;
				$threads[$ID]['number'] = $i;
				$threads[$ID]['group'] = $group;
				$threads[$ID]['date'] = $message['Date']['0'];
				$threads[$ID]['from'] = $message['From']['0'];
				$threads[$ID]['subject'] = $message['Subject']['0'];
				$threads[$ID]['content-type'] = $message['Content-Type']['0'];
				if(isset($threads[$ID]['content-encoding'])){
					$threads[$ID]['content-encoding'] = $message['Content-Transfer-Encoding']['0'];
				}
				if( (isset($message['References']['0'])) && ($message['References']['0']) ){
					$Ref = $message['References']['0'];
					$firstRef = explode("<", $Ref);
					$Ref = ("<" . $firstRef[1]);
					$threads[$ID]['op'] = false;
					$threads[$ID]['ref'] = $Ref;
					$threads[$ID]['ref_org'] = $message['References']['0'];
					$threads[$ID]['solved'] = false;
				} else {
					$threads[$ID]['op'] = true;
					$threads[$ID]['solved'] = true;
				}
				array_push($watermarks[$group],$i);
			}
	}
	$jsonFile = fopen('./threads/xt_' . $group . '.json', 'w');
	fwrite($jsonFile, json_encode($threads, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
	fclose($jsonFile);
	$jsonWatermarks = fopen('./watermarks/' . $name . '_xw_' . $group . '.json', 'w');
	fwrite($jsonWatermarks, json_encode((array) $watermarks, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
	fclose($jsonWatermarks);
	return;
}
function update_threads($groups, $nntp, $groupInfo, $name){
	foreach($groups as $group){
		$update = false;
//		echo("updating index for group " . $group . "\n\r");
		$hi = ( $groupInfo[$group][0] + 1);
		$lo = $groupInfo[$group][1];
//		$lo = ( $hi - 20);
// use the line above if you want to limit the number of articles that are downloaded	
		if($lo < 1){
			$lo = 1;
		}
		$threads = json_decode(file_get_contents('./threads/xt_' . $group . '.json'), true);
		if(file_exists('./watermarks/' . $name . '_xw_' . $group . '.json')){
			$watermarks = json_decode(file_get_contents('./watermarks/' . $name . '_xw_' . $group . '.json'), true);
		} else {
			$watermarks = array();
			$watermarks[$group] = array();
		}
		for ($i = $lo; $i < $hi; $i++){
			if(!in_array($i,$watermarks[$group])){
				$message = get_message($i, $group, $nntp);
				$update = true;
				if( (isset($message['Message-ID']['0'])) && ($message) && ($message['Message-ID']['0']) && (!array_key_exists($message['Message-ID']['0'], $threads)) ){
					echo("processing message # " . $i . " from group " . $group . "\r");
					$ID = trim($message['Message-ID']['0']);
					$threads[$ID] = array();
					$threads[$ID]['parents'] = array();
					$threads[$ID]['synced'] = false;
					$threads[$ID]['number'] = $i;
					$threads[$ID]['group'] = $group;
					$threads[$ID]['date'] = $message['Date']['0'];
					$threads[$ID]['from'] = $message['From']['0'];
					$threads[$ID]['subject'] = $message['Subject']['0'];
					$threads[$ID]['content-type'] = $message['Content-Type']['0'];
					$threads[$ID]['content-encoding'] = $message['Content-Transfer-Encoding']['0'];
					if( (isset($message['References']['0'])) && ($message['References']['0']) ){
						$Ref = $message['References']['0'];
						$firstRef = explode("<", $Ref);
						$Ref = ("<" . $firstRef[1]);
						$threads[$ID]['op'] = false;
						$threads[$ID]['ref'] = $Ref;
						$threads[$ID]['ref_org'] = $message['References']['0'];
						$threads[$ID]['solved'] = false;
					} else {
						$threads[$ID]['op'] = true;
						$threads[$ID]['solved'] = true;
					}
				} else {
					echo("skipping message # " . $i . " from group " . $group . "\r");
				}
				array_push($watermarks[$group],$i);
			}
		}
		if($update){
			echo("update for group " . $group . "\n\r");
			$jsonFile = fopen('./threads/xt_' . $group . '.json', 'w');
			fwrite($jsonFile, json_encode($threads, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
			fclose($jsonFile);
			$jsonWatermarks = fopen('./watermarks/' . $name . '_xw_' . $group . '.json', 'w');
			fwrite($jsonWatermarks, json_encode((array) $watermarks, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
			fclose($jsonWatermarks);
		}
	}
}

function stage($thread_keys, $threads){
	foreach($thread_keys as $thread_key){
		if( (isset($threads[$thread_key])) && ($threads[$thread_key]['solved'] !== true) && ($threads[$thread_key]['op'] !== true) ){
			if ($threads[$thread_key]['parents']){
				$to_check = trim(end($threads[$thread_key]['parents']));
				if(!array_key_exists($to_check, $threads)){
					$threads[$thread_key]['missing_ref'] = $to_check;
				} else {
					if($threads[$to_check]['op'] == true){
						$threads[$thread_key]['ref'] = $to_check;
						$threads[$thread_key]['solved'] = true;
					} else {
						array_push($threads[$thread_key]['parents'], trim($threads[$to_check]['ref']));
						array_filter($threads[$thread_key]['parents'], static function($var){return $var !== null;} );
					}
				}
			} elseif ($threads[$thread_key]['ref']){
				array_push($threads[$thread_key]['parents'], trim($threads[$thread_key]['ref']));
			}
		}
	}
	return $threads;
}

function update_sync($threads, $group){
	$counter = 0;
	$fails = array();
	$update = false;
	$thread_keys = array_keys($threads);
	foreach($thread_keys as $thread_key){
		if( ($threads[$thread_key]['synced'] == false) && ($threads[$thread_key]['solved'] == true) ){
			echo("syncing message # " . $threads[$thread_key]['number'] . " from group " . $threads[$thread_key]['group'] . "\n\r");
			$article = (array) vichan_message_read($threads[$thread_key]['number'], $threads[$thread_key]['group']);
			$articleToSend = (array) $article['header'];
			unset($articleToSend['references']);
			if( (isset($threads[$thread_key]['ref'])) && ($threads[$thread_key]['ref']) ){
				$articleToSend['references'] = array();
				$articleToSend['references']['0'] = $threads[$thread_key]['ref'];
			}
			$articleToSend[] = $article['body']['0'];
			$update = true;
			$threads[$thread_key]['synced'] = true;
			if( (isset($articleToSend['content_type']['1'])) && (isset($articleToSend['content_type_name']['1'])) && (isset($article['body']['1'])) ){
				$articleToSend['attachment_type'] = $articleToSend['content_type']['1'];
				$articleToSend['attachment_name'] = $articleToSend['content_type_name']['1'];
				$articleToSend['attachment'] = base64_encode($article['body']['1']);
			}
			$result = send_article($articleToSend);
			echo($result . "\n\r");
			$pos = strpos($result, 'error');
			if ($pos === false) {
				$threads[$thread_key]['synced_success'] = true;
			} else {
				$threads[$thread_key]['synced_success'] = false;
				$threads[$thread_key]['synced_error'] = $result;
			}
			$counter++;
			if($counter > 10){
				echo("saving updated syncing for group: " . $group . "\n\r");
				$jsonFile = fopen('./threads/xt_' . $group . '.json', 'w');
				fwrite($jsonFile, json_encode($threads, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
				fclose($jsonFile);
				$counter = 0;
			}
		}
	}
	if($update){
		echo("saving updated syncing for group: " . $group . "\n\r");
		$jsonFile = fopen('./threads/xt_' . $group . '.json', 'w');
		fwrite($jsonFile, json_encode($threads, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES));
		fclose($jsonFile);
	} else {
		echo("no new files found for syncing in group " . $group . "\n\r");
	}

}

function send_article($article){
	$url = 'http://127.0.0.1:12080/gpost.php';
	// Create a new cURL resource
	$ch = curl_init($url);
	// Setup request to send json via POST
	$payload = json_encode(array($article));
	// Attach encoded JSON string to the POST fields
	curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
/*
insert: server.reject-expect-100-with-417 = "disable" in your lighttpd.conf if you get a 417 error 
*/
	curl_setopt($ch, CURLOPT_NOPROXY, "*");
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
	// Return response instead of outputting
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	// Execute the POST request
	$result = curl_exec($ch);
	// Close cURL resource
	curl_close($ch);
	return $result;
}
?>
