<?php
/*
 *  Copyright (c) 2010-2014 Tinyboard Development Group
 */
require_once 'inc/functions.php';
require_once 'inc/anti-bot.php';
require_once 'inc/bans.php';


if ( ($_SERVER['REMOTE_ADDR'] != '0.0.0.0') && ($_SERVER['REMOTE_ADDR'] != '127.0.0.1') ) {
                error("....intruder alert....intruder alert....");
        }
$rawData = json_decode(file_get_contents('php://input'), true);

$data['Message-ID'] = $rawData['0']['id'];
$data['From'] = $rawData['0']['from'];
$data['Newsgroups'] = $rawData['0']['newsgroups'];

if(isset($rawData['0']['references']['0'])){
	$data['References'] = $rawData['0']['references']['0'];
}
$data['Date'] = $rawData['0']['date'];
$data['Content-Type'] = $rawData['0']['content_type']['0'];
$data['Content'] = $rawData['0']['0'];
$data['Subject'] = $rawData['0']['subject'];

$dropped_post = false;

$_POST = array();
$_POST['json_response'] = true;

$headers = json_encode($data);

if (!isset ($data['Message-ID'])) {
	error("NNTPChan: No message ID");
} else {
	 $msgid = $data['Message-ID'];
}

$groups = preg_split("/,\s*/", $data['Newsgroups']);
$group = $groups[0];
$translation = array(
	'rocksolid.nodes' => 'n',
	'rocksolid.nodes.help' => 'nh',
	'rocksolid.nodes.announce' => 'na',
	'rocksolid.shared.encryption' => 'ec',
	'rocksolid.shared.entertainment' => 'et',
	'rocksolid.shared.freenet' => 'f',
	'rocksolid.shared.general' => 'g',
	'rocksolid.shared.hacking' => 'ha',
	'rocksolid.shared.helpdesk' => 'he',
	'rocksolid.shared.i2p' => 'i',
	'rocksolid.shared.linux' => 'l',
	'rocksolid.shared.news' => 'ne',
	'rocksolid.shared.offtopic' => 'b',
	'rocksolid.programming' => 'code',
	'rocksolid.shared.rocksolid' => 'r',
	'rocksolid.shared.security' => 'opsec',
	'rocksolid.social' => 'soc',
	'rocksolid.shared.test' => 'ts',
	'rocksolid.shared.tor' => 'to',
);

$xboard = $translation[$group];
$ref = null;
if (isset ($data['References'])) {
	$ref = $data['References'];
	$query = prepare("SELECT `board`,`id` FROM ``nntp_references`` WHERE `message_id` = :ref");
        $query->bindValue(':ref', $ref);
        $query->execute() or error(db_error($query));
	$ary = $query->fetchAll(PDO::FETCH_ASSOC);
	if (count($ary) == 0) {
		error("NNTPChan: We don't have $ref that $msgid references");
	}
	$p_id = $ary[0]['id'];
	$p_board = $ary[0]['board'];
	if ($p_board != $xboard) {
		error("NNTPChan: Cross board references not allowed. Tried to reference $p_board on $xboard");
	}
	$_POST['thread'] = $p_id;
}
$date = $data['Date'];

list($ct) = explode('; ', $data['Content-Type']);

$query = prepare("SELECT COUNT(*) AS `c` FROM ``nntp_references`` WHERE `message_id` = :msgid");
$query->bindValue(":msgid", $msgid);
$query->execute() or error(db_error($query));
$a = $query->fetch(PDO::FETCH_ASSOC);
if ($a['c'] > 0) {
	error("NNTPChan: We already have this post. Post discarded.");
}
$content = $data['Content'];
$_POST['board'] = $xboard;
$name = '';

$content = preg_replace_callback('/>>([0-9a-fA-F]{6,})/', function($id) use ($xboard) {
	$id = $id[1];

	$query = prepare("SELECT `board`,`id` FROM ``nntp_references`` WHERE `message_id_digest` LIKE :rule");
	$idx = $id . "%";
        $query->bindValue(':rule', $idx);
        $query->execute() or error(db_error($query));
		
	$ary = $query->fetchAll(PDO::FETCH_ASSOC);
	if (count($ary) == 0) {
		return ">>>>$id";
	}
	else {
		$ret = array();
		foreach ($ary as $v) {
			if ($v['board'] != $xboard) {
				$ret[] = ">>>/".$v['board']."/".$v['id'];
			}
			else {
				$ret[] = ">>".$v['id'];
			}
		}
		return implode($ret, ", ");
	}
}, $content);

$_POST['body'] = $content;

$dropped_post = array(
	'date' => $date,
	'board' => $xboard,
	'msgid' => $msgid,
	'headers' => $headers,
	'from_nntp' => true,
);

$post = array('board' => $_POST['board'], 'files' => array());

	// Check if board exists
if (!openBoard($post['board']))
	error($config['error']['noboard']);

$data['name'] = $data['From'];
	
if (!isset($data['email']))
	$data['email'] = '';
	
if (!isset($data['subject']))
	$data['subject'] = '';
	
$_POST['password'] = '';	
	
if (isset($_POST['thread'])) {
	$post['op'] = false;
	$post['thread'] = round($_POST['thread']);
} else
	$post['op'] = true;
$mod = $post['mod'] = false;
	
//Check if thread exists
if (!$post['op']) {
	$query = prepare(sprintf("SELECT `sticky`,`locked`,`cycle`,`sage`,`slug` FROM ``posts_%s`` WHERE `id` = :id AND `thread` IS NULL LIMIT 1", $board['uri']));
	$query->bindValue(':id', $post['thread'], PDO::PARAM_INT);
	$query->execute() or error(db_error());
	
	if (!$thread = $query->fetch(PDO::FETCH_ASSOC)) {
		// Non-existant
		error($config['error']['nonexistant']);
	}
}
else {
	$thread = false;
}

/*
if ($config['field_disable_name'])
	$data['name'] = $config['anonymous']; // "forced anonymous"
*/	
if ($config['field_disable_email'])
	$data['email'] = '';
	
if ($config['field_disable_password'])
	$data['password'] = '';

if ($config['field_disable_subject'] || (!$post['op'] && $config['field_disable_reply_subject']))
	$_POST['subject'] = '';
	
$post['name'] = $data['name'] != '' ? $data['name'] : $config['anonymous'];
$post['subject'] = $data['Subject'];
$post['email'] = str_replace(' ', '%20', htmlspecialchars($data['From']));
$post['body'] = $data['Content'];
$post['password'] = '';
	
if (!$post['op']) {
          $numposts = numPosts($post['thread']);
}
$post['has_file'] = false;
if (isset($rawData['0']['attachment'])) {
	echo 'ok, got attachment';
        $post['file_tmp'] = tempnam($config['tmp'], 'url');
	$fp = fopen($post['file_tmp'], 'w');
	fwrite($fp, base64_decode($rawData['0']['attachment']));
	fclose($fp);
	$_FILES['file'] = array(
		'name' => basename($rawData['0']['attachment_name']),
		'tmp_name' => $post['file_tmp'],
		'file_tmp' => true,
		'error' => 0,
		'size' => filesize($post['file_tmp']),
		);
	$post['has_file'] = true;
	print_r($_FILES['file']);
	print_r($post);
}
		
if ($post['has_file']) {
	// Determine size sanity
	$size = 0;
	if ($config['multiimage_method'] == 'split') {
		foreach ($_FILES as $key => $file) {
			$size += $file['size'];
		}
	} elseif ($config['multiimage_method'] == 'each') {
		foreach ($_FILES as $key => $file) {
			if ($file['size'] > $size) {
				$size = $file['size'];
			}
		}
	} else {
		error(_('Unrecognized file size determination method.'));
	}
	if ($size > $config['max_filesize'])
		error(sprintf3($config['error']['filesize'], array(
			'sz' => number_format($size),
			'filesz' => number_format($size),
			'maxsz' => number_format($config['max_filesize'])
		)));
	$post['filesize'] = $size;
}


$post['capcode'] = false;

if ($mod && preg_match('/^((.+) )?## (.+)$/', $post['name'], $matches)) {
	$name = $matches[2] != '' ? $matches[2] : $config['anonymous'];
	$cap = $matches[3];

	if (isset($config['mod']['capcode'][$mod['type']])) {
		if (	$config['mod']['capcode'][$mod['type']] === true ||
			(is_array($config['mod']['capcode'][$mod['type']]) &&
				in_array($cap, $config['mod']['capcode'][$mod['type']])
			)) {

			$post['capcode'] = utf8tohtml($cap);
			$post['name'] = $name;
		}
	}
}

$trip = generate_tripcode($post['name']);
$post['name'] = $trip[0];
$post['trip'] = isset($trip[1]) ? $trip[1] : ''; // XX: Dropped posts and tripcodes

$noko = true;
$post['email'] = '';

	if ($post['has_file']) {
		$i = 0;
		foreach ($_FILES as $key => $file) {
			if (!in_array($file['error'], array(UPLOAD_ERR_NO_FILE, UPLOAD_ERR_OK))) {
				error(sprintf3($config['error']['phpfileserror'], array(
					'index' => $i+1,
					'code' => $file['error']
				)));
			}

			if ($file['size'] && $file['tmp_name']) {
				$file['filename'] = urldecode($file['name']);
				$file['extension'] = strtolower(mb_substr($file['filename'], mb_strrpos($file['filename'], '.') + 1));
				if (isset($config['filename_func']))
					$file['file_id'] = $config['filename_func']($file);
				else
					$file['file_id'] = time() . substr(microtime(), 2, 3);

				if (sizeof($_FILES) > 1)
					$file['file_id'] .= "-$i";

				$file['file'] = $board['dir'] . $config['dir']['img'] . $file['file_id'] . '.' . $file['extension'];
				$file['thumb'] = $board['dir'] . $config['dir']['thumb'] . $file['file_id'] . '.' . ($config['thumb_ext'] ? $config['thumb_ext'] : $file['extension']);
				$post['files'][] = $file;
				$i++;
			}
		}
	}

	if (empty($post['files'])) $post['has_file'] = false;

	echo("DEBUG, post_has_file is: " . $post['has_file'] . "\n\r");

	if ($config['strip_combining_chars']) {
		$post['name'] = strip_combining_chars($post['name']);
		$post['email'] = strip_combining_chars($post['email']);
		$post['subject'] = strip_combining_chars($post['subject']);
		$post['body'] = strip_combining_chars($post['body']);
	}
	
	wordfilters($post['body']);
	
	$post['body'] = escape_markup_modifiers($post['body']);
	
	if ($config['allowed_tags'] && $post['op'] && isset($data['tag']) && isset($config['allowed_tags'][$data['tag']])) {
		$post['body'] .= "\n<tinyboard tag>" . $data['tag'] . "</tinyboard>";
	}

	
	if (mysql_version() >= 50503) {
		$post['body_nomarkup'] = $post['body']; // Assume we're using the utf8mb4 charset
	} else {
		// MySQL's `utf8` charset only supports up to 3-byte symbols
		// Remove anything >= 0x010000
		
		$chars = preg_split('//u', $post['body'], -1, PREG_SPLIT_NO_EMPTY);
		$post['body_nomarkup'] = '';
		foreach ($chars as $char) {
			$o = 0;
			$ord = ordutf8($char, $o);
			if ($ord >= 0x010000)
				continue;
			$post['body_nomarkup'] .= $char;
		}
	}
	
	$post['tracked_cites'] = markup($post['body'], true);

	
	
	if ($post['has_file']) {
		$md5cmd = false;
		if ($config['bsd_md5'])  $md5cmd = '/sbin/md5 -r';
		if ($config['gnu_md5'])  $md5cmd = 'md5sum';

		$allhashes = '';

		foreach ($post['files'] as $key => &$file) {
			if ($post['op'] && $config['allowed_ext_op']) {
				if (!in_array($file['extension'], $config['allowed_ext_op']))
					error($config['error']['unknownext']);
			}
			elseif (!in_array($file['extension'], $config['allowed_ext']) && !in_array($file['extension'], $config['allowed_ext_files']))
				error($config['error']['unknownext']);
			
			$file['is_an_image'] = !in_array($file['extension'], $config['allowed_ext_files']);
			
			// Truncate filename if it is too long
			$file['filename'] = mb_substr($file['filename'], 0, $config['max_filename_len']);
			
			$upload = $file['tmp_name'];
			
			if (!is_readable($upload))
				error($config['error']['nomove']);

			if ($md5cmd) {
				$output = shell_exec_error($md5cmd . " " . escapeshellarg($upload));
				$output = explode(' ', $output);
				$hash = $output[0];
			}
			else {
				$hash = md5_file($upload);
			}

			$file['hash'] = $hash;
			$allhashes .= $hash;
		}

		if (count ($post['files']) == 1) {
			$post['filehash'] = $hash;
		}
		else {
			$post['filehash'] = md5($allhashes);
		}
	}

	if ($post['has_file']) {
		foreach ($post['files'] as $key => &$file) {
		if ($file['is_an_image']) {
			if ($config['ie_mime_type_detection'] !== false) {
				// Check IE MIME type detection XSS exploit
				$buffer = file_get_contents($upload, null, null, null, 255);
				if (preg_match($config['ie_mime_type_detection'], $buffer)) {
					undoImage($post);
					error($config['error']['mime_exploit']);
				}
			}
			
			require_once 'inc/image.php';
			
			// find dimensions of an image using GD
			if (!$size = @getimagesize($file['tmp_name'])) {
				error($config['error']['invalidimg']);
			}
			if (!in_array($size[2], array(IMAGETYPE_PNG, IMAGETYPE_GIF, IMAGETYPE_JPEG, IMAGETYPE_BMP))) {
				error($config['error']['invalidimg']);
			}
			if ($size[0] > $config['max_width'] || $size[1] > $config['max_height']) {
				error($config['error']['maxsize']);
			}
			
			
			if ($config['convert_auto_orient'] && ($file['extension'] == 'jpg' || $file['extension'] == 'jpeg')) {
				// The following code corrects the image orientation.
				// Currently only works with the 'convert' option selected but it could easily be expanded to work with the rest if you can be bothered.
				if (!($config['redraw_image'] || (($config['strip_exif'] && !$config['use_exiftool']) && ($file['extension'] == 'jpg' || $file['extension'] == 'jpeg')))) {
					if (in_array($config['thumb_method'], array('convert', 'convert+gifsicle', 'gm', 'gm+gifsicle'))) {
						$exif = @exif_read_data($file['tmp_name']);
						$gm = in_array($config['thumb_method'], array('gm', 'gm+gifsicle'));
						if (isset($exif['Orientation']) && $exif['Orientation'] != 1) {
							if ($config['convert_manual_orient']) {
								$error = shell_exec_error(($gm ? 'gm ' : '') . 'convert ' .
									escapeshellarg($file['tmp_name']) . ' ' .
									ImageConvert::jpeg_exif_orientation(false, $exif) . ' ' .
									($config['strip_exif'] ? '+profile "*"' :
										($config['use_exiftool'] ? '' : '+profile "*"')
									) . ' ' .
									escapeshellarg($file['tmp_name']));
								if ($config['use_exiftool'] && !$config['strip_exif']) {
									if ($exiftool_error = shell_exec_error(
										'exiftool -overwrite_original -q -q -orientation=1 -n ' .
											escapeshellarg($file['tmp_name'])))
										error(_('exiftool failed!'), null, $exiftool_error);
								} else {
									// TODO: Find another way to remove the Orientation tag from the EXIF profile
									// without needing `exiftool`.
								}
							} else {
								$error = shell_exec_error(($gm ? 'gm ' : '') . 'convert ' .
										escapeshellarg($file['tmp_name']) . ' -auto-orient ' . escapeshellarg($upload));
							}
							if ($error)
								error(_('Could not auto-orient image!'), null, $error);
							$size = @getimagesize($file['tmp_name']);
							if ($config['strip_exif'])
								$file['exif_stripped'] = true;
						}
					}
				}
			}
			
			// create image object
			$image = new Image($file['tmp_name'], $file['extension'], $size);
			if ($image->size->width > $config['max_width'] || $image->size->height > $config['max_height']) {
				$image->delete();
				error($config['error']['maxsize']);
			}
			
			$file['width'] = $image->size->width;
			$file['height'] = $image->size->height;
			
			if ($config['spoiler_images'] && isset($data['spoiler'])) {
				$file['thumb'] = 'spoiler';
				
				$size = @getimagesize($config['spoiler_image']);
				$file['thumbwidth'] = $size[0];
				$file['thumbheight'] = $size[1];
			} elseif ($config['minimum_copy_resize'] &&
				$image->size->width <= $config['thumb_width'] &&
				$image->size->height <= $config['thumb_height'] &&
				$file['extension'] == ($config['thumb_ext'] ? $config['thumb_ext'] : $file['extension'])) {
			
				// Copy, because there's nothing to resize
				copy($file['tmp_name'], $file['thumb']);
			
				$file['thumbwidth'] = $image->size->width;
				$file['thumbheight'] = $image->size->height;
			} else {
				$thumb = $image->resize(
					$config['thumb_ext'] ? $config['thumb_ext'] : $file['extension'],
					$post['op'] ? $config['thumb_op_width'] : $config['thumb_width'],
					$post['op'] ? $config['thumb_op_height'] : $config['thumb_height']
				);
				
				$thumb->to($file['thumb']);
			
				$file['thumbwidth'] = $thumb->width;
				$file['thumbheight'] = $thumb->height;
			
				$thumb->_destroy();
			}
			
			if ($config['redraw_image'] || (!@$file['exif_stripped'] && $config['strip_exif'] && ($file['extension'] == 'jpg' || $file['extension'] == 'jpeg'))) {
				if (!$config['redraw_image'] && $config['use_exiftool']) {
					if($error = shell_exec_error('exiftool -overwrite_original -ignoreMinorErrors -q -q -all= ' .
						escapeshellarg($file['tmp_name'])))
						error(_('Could not strip EXIF metadata!'), null, $error);
				} else {
					$image->to($file['file']);
					$dont_copy_file = true;
				}
			}
			$image->destroy();
		} else {
			// not an image
			//copy($config['file_thumb'], $post['thumb']);
			$file['thumb'] = 'file';

			$size = @getimagesize(sprintf($config['file_thumb'],
				isset($config['file_icons'][$file['extension']]) ?
					$config['file_icons'][$file['extension']] : $config['file_icons']['default']));
			$file['thumbwidth'] = $size[0];
			$file['thumbheight'] = $size[1];
		}

		if ($config['tesseract_ocr'] && $file['thumb'] != 'file') { // Let's OCR it!
			$fname = $file['tmp_name'];

			if ($file['height'] > 500 || $file['width'] > 500) {
				$fname = $file['thumb'];
			}

			if ($fname == 'spoiler') { // We don't have that much CPU time, do we?
			}
			else {
				$tmpname = "tmp/tesseract/".rand(0,10000000);

				// Preprocess command is an ImageMagick b/w quantization
				$error = shell_exec_error(sprintf($config['tesseract_preprocess_command'], escapeshellarg($fname)) . " | " .
                                                          'tesseract stdin '.escapeshellarg($tmpname).' '.$config['tesseract_params']);
				$tmpname .= ".txt";

				$value = @file_get_contents($tmpname);
				@unlink($tmpname);

				if ($value && trim($value)) {
					// This one has an effect, that the body is appended to a post body. So you can write a correct
					// spamfilter.
					$post['body_nomarkup'] .= "<tinyboard ocr image $key>".htmlspecialchars($value)."</tinyboard>";
				}
			}
		}
		
		if (!isset($dont_copy_file) || !$dont_copy_file) {
			if (isset($file['file_tmp'])) {
				if (!@rename($file['tmp_name'], $file['file']))
					error($config['error']['nomove']);
				chmod($file['file'], 0644);
			} elseif (!@move_uploaded_file($file['tmp_name'], $file['file']))
				error($config['error']['nomove']);
			}
		}

		if ($config['image_reject_repost']) {
			if ($p = getPostByHash($post['filehash'])) {
				undoImage($post);
				error(sprintf($config['error']['fileexists'], 
					($post['mod'] ? $config['root'] . $config['file_mod'] . '?/' : $config['root']) .
					($board['dir'] . $config['dir']['res'] .
						($p['thread'] ?
							$p['thread'] . '.html#' . $p['id']
						:
							$p['id'] . '.html'
						))
				));
			}
		} else if (!$post['op'] && $config['image_reject_repost_in_thread']) {
			if ($p = getPostByHashInThread($post['filehash'], $post['thread'])) {
				undoImage($post);
				error(sprintf($config['error']['fileexistsinthread'], 
					($post['mod'] ? $config['root'] . $config['file_mod'] . '?/' : $config['root']) .
					($board['dir'] . $config['dir']['res'] .
						($p['thread'] ?
							$p['thread'] . '.html#' . $p['id']
						:
							$p['id'] . '.html'
						))
				));
			}
		}
		}
	
	
	// Remove board directories before inserting them into the database.
	if ($post['has_file']) {
		foreach ($post['files'] as $key => &$file) {
			$file['file_path'] = $file['file'];
			$file['thumb_path'] = $file['thumb'];
			$file['file'] = mb_substr($file['file'], mb_strlen($board['dir'] . $config['dir']['img']));
			if ($file['is_an_image'] && $file['thumb'] != 'spoiler')
				$file['thumb'] = mb_substr($file['thumb'], mb_strlen($board['dir'] . $config['dir']['thumb']));
		}
	}
	
	$post = (object)$post;
	$post->files = array_map(function($a) { return (object)$a; }, $post->files);

	$error = event('post', $post);
	$post->files = array_map(function($a) { return (array)$a; }, $post->files);

	if ($error) {
		undoImage((array)$post);
		error($error);
	}
	$post = (array)$post;

	if ($post['files'])
		$post['files'] = $post['files'];
	$post['num_files'] = sizeof($post['files']);
	
	$post['time'] = $date;

	$post['id'] = $id = post($post);
	$post['slug'] = slugify($post);
	

    $query = prepare("INSERT INTO ``nntp_references`` (`board`, `id`, `message_id`, `message_id_digest`, `own`, `headers`) VALUES ".
	                                                         "(:board , :id , :message_id , :message_id_digest , false, :headers)");

	$query->bindValue(':board', $dropped_post['board']);
	$query->bindValue(':id', $id);
	$query->bindValue(':message_id', $dropped_post['msgid']);
	$query->bindValue(':message_id_digest', sha1($dropped_post['msgid']));
	$query->bindValue(':headers', $dropped_post['headers']);
	$query->execute() or error(db_error($query));

	insertFloodPost($post);

	// Handle cyclical threads
	if (!$post['op'] && isset($thread['cycle']) && $thread['cycle']) {
		// Query is a bit weird due to "This version of MariaDB doesn't yet support 'LIMIT & IN/ALL/ANY/SOME subquery'" (MariaDB Ver 15.1 Distrib 10.0.17-MariaDB, for Linux (x86_64))
		$query = prepare(sprintf('DELETE FROM ``posts_%s`` WHERE `thread` = :thread AND `id` NOT IN (SELECT `id` FROM (SELECT `id` FROM ``posts_%s`` WHERE `thread` = :thread ORDER BY `id` DESC LIMIT :limit) i)', $board['uri'], $board['uri']));
		$query->bindValue(':thread', $post['thread']);
		$query->bindValue(':limit', $config['cycle_limit'], PDO::PARAM_INT);
		$query->execute() or error(db_error($query));
	}
	
	
	if (isset($post['tracked_cites']) && !empty($post['tracked_cites'])) {
		$insert_rows = array();
		foreach ($post['tracked_cites'] as $cite) {
			$insert_rows[] = '(' .
				$pdo->quote($board['uri']) . ', ' . (int)$id . ', ' .
				$pdo->quote($cite[0]) . ', ' . (int)$cite[1] . ')';
		}
		query('INSERT INTO ``cites`` VALUES ' . implode(', ', $insert_rows)) or error(db_error());
	}
	
	if (!$post['op'] && strtolower($post['email']) != 'sage' && !$thread['sage'] && ($config['reply_limit'] == 0 || $numposts['replies']+1 < $config['reply_limit'])) {
		bumpThread($post['thread']);
	}
	
	
	$root = $post['mod'] ? $config['root'] . $config['file_mod'] . '?/' : $config['root'];
	
	buildThread($post['op'] ? $id : $post['thread']);
		
	if ($config['try_smarter'] && $post['op'])
		$build_pages = range(1, $config['max_pages']);
	
	if ($post['op'])
		clean($id);
	
	event('post-after', $post);
	
	buildIndex();

	if ($post['op'])
		rebuildThemes('post-thread', $board['uri']);
	else
		rebuildThemes('post', $board['uri']);
		
